<template>
  <div>
    <v-card v-if="campaign.id">
        <v-img
            :src="campaign.image"
            class="white--text"
            height="200px"
        >
            <v-card-title 
                class="fill-height align-end"
                v-text="campaign.title">
            </v-card-title>
        </v-img>

        <v-card-text>
            <v-simple-table dense>
                <tbody>
                    <tr>
                        <td><v-icon>mdi-home-city</v-icon> Alamat</td>
                        <td>{{ campaign.address }}</td>
                    </tr>
                    <tr>
                        <td><v-icon>mdi-hand-heart</v-icon> Terkumpul</td>
                        <td class="blue--text"> Rp {{ campaign.collected.toLocaleString('id-ID')}}</td>
                    </tr>
                
                    <tr>
                        <td><v-icon>mdi-cash</v-icon>  Dibutuhkan</td>
                        <td class="orange--text">Rp {{ campaign.required.toLocaleString('id-ID')}}</td>
                    </tr>
                </tbody>
            </v-simple-table>
            Description: <br>
            {{ campaign.description }}
          
           
        </v-card-text>
        <v-card-actions>
            <v-btn block color="primary" @click="donate" :disabled="campaign.collected >= campaign.required">
                <v-icon>mdi-money</v-icon> &nbsp;
                DONATE
            </v-btn>
        </v-card-actions>
    </v-card>
  </div>
</template>

<script>
    import { mapActions, mapMutations , mapGetters} from 'vuex';
    export default {
        data: () => ({
            campaign: {}, // objek campaign
        }),
        created(){
            this.go()
           
        },
        computed : {
            ...mapGetters({
              donations : 'donation/donations',
              countDonations : 'donation/count'
            }),
        },
        methods: {

            ...mapMutations({
                tambahTransaksi : 'transaction/insert'
            }),

            ...mapActions({
                setAlert              : 'alert/set',
                setDialogComponent    : 'dialog/setComponent',
            }),

            donate(){             
                
                if (this.countDonations > 0) {
                    
                    let check = this.donations.some(item => item.campaign.id === this.campaign.id)
                
                    if (check) {
                        this.setAlert({
                            status : true,
                            color  : 'warning',
                            text   : 'Anda sudah menambahakn campaign ini dalam daftar donasi Anda, segera lakukan pembayaran',
                        })
                    }else{
                        this.setDialogComponent({'component' : 'donation' , 'params' : this.campaign})
                    }
                   
                }else{
                    this.setDialogComponent({'component' : 'donation' , 'params' : this.campaign})
                }
                                           
            },

            go(){
                let { id } = this.$route.params
                let url = '/api/campaign/'+id
                axios.get(url)
                .then((response) => {           
                    let { data } = response.data
                    this.campaign = data.campaign
                })
                .catch((error) => {
                    let { responses } = error
                    console.log(responses)
                }) 
            },
          
        
        },
      
      
    };
</script>